# -*- mode: perl -*-
# $Id: xaway.pl 10 2005-11-20 03:49:15Z dmw $

use strict;
use vars qw($VERSION %IRSSI);

use Irssi;

$VERSION = '1.1.$Revision: 10 $';
%IRSSI = (
		  authors	=> "sickd",
		  contact	=> 'dmw@unete.cl',
		  name	=> "xaway",
		  description	=> "Extended Away",
		  license	=> "Public Domain",
		  changed	=> '$Date: 2005-11-20 00:49:15 -0300 (dom, 20 nov 2005) $',
		  changes	=> "see ChangeLog"
		  );

use Irssi::TextUI;

my (%server_times);
my ($xaway_server, $xaway_time, $xaway_left);

sub buildTimeStr {
    my ($time) = @_;
	my ($c, $cd, $timerstr, @time_parts);
	my (@time_strings) = ('second', 'minute', 'hour', 'day', 'month', 'year');
    my (@away_time) = gmtime($time);
	$c = 5;
	while ($c >= 0) {
		$cd = $away_time[$c];
		if ($c == 5) { $cd -= 70; }
		if ($c == 3) { $cd -= 1; }
		if ($cd > 0 && $c < 6) {
			if ($cd == 1) {
				push(@time_parts, ($cd . " " . $time_strings[$c]));
			} else {
				push(@time_parts, ($cd . " " . $time_strings[$c] . "s"));
			}
		}
		$c--;
	}
	$timerstr = join(', ', @time_parts);
    return $timerstr;
}

sub cmdXAway {
    my ($data, $server, $witem) = @_;
    my ($message, $cmd, $window);
    my ($witemx);
    my ($skey);
    if (!$server || !$server->{connected}) {
        Irssi::print("\002xaway\002: \002-!-\002 Not connected to server");
        return;
    }
    if (!$xaway_time) {
        if ($data) {
            $message = "/me is away: \002" . $data . "\002";
            $cmd = '/away ' . $data;
        } else {
            $message = '/me is away (no reason)';
            $cmd = '/away with no reason';
        }
        $xaway_time = time();
        foreach $window (Irssi::windows()) {
            foreach $witemx ($window->items()) {
                if ($witemx && ($witemx->{type} eq "CHANNEL")) {
                    $witemx->command($message);
                }
            }
        }
        Irssi::active_win()->command($cmd);
    } else {
        $xaway_left = time() - $xaway_time;
        $message = "/me is back (gone\002:\002 " .
                   buildTimeStr($xaway_left) . ')';
        $cmd = '/away';
        Irssi::active_win()->command($cmd);
        foreach $window (Irssi::windows()) {
            foreach $witemx ($window->items()) {
                if ($witemx && ($witemx->{type} eq "CHANNEL")) {
                    $witemx->command($message);
                }
            }
        }
        $xaway_left = 0;
        $xaway_time = 0;
    }
}

sub cmdXAReset {
    $xaway_left = 0;
    $xaway_time = 0;
}

sub cmdXAStatus {
	my ($msg);
	$xaway_left = time() - $xaway_time;
	$msg  = "\002xaway\002: \002-!-\002";
	$msg .= " " . buildTimeStr($xaway_left);
	Irssi::active_win()->print($msg);
}

Irssi::command_bind('xaway', 'cmdXAway');
Irssi::command_bind('xaway_reset', 'cmdXAReset');
Irssi::command_bind('xaway_status', 'cmdXAStatus');

# vim: set ft=perl ff=unix ts=4 sw=4 enc=latin1 expandtab:
