# -*- mode: perl; -*-
# $Id: xmms.pl 67 2006-09-15 22:44:36Z dmw $

use strict;
use vars qw($VERSION %IRSSI);

use Irssi;

$VERSION = '1.1.$Revision: 67 $';
%IRSSI = (
    authors	=> "sickd",
    contact	=> 'dmw@unete.cl',
    name	=> "XMMS Playing Song",
    description	=> "Announces XMMS Playing Song",
    license	=> "Public Domain",
    url		=> "http://www.linux-chile.org/docs.php?op=verVersion&doc=17&id=1",
    changed	=> '$Date: 2006-09-15 18:44:36 -0400 (vie, 15 sep 2006) $',
    changes	=> "see ChangeLog"
);

use Irssi::TextUI;

sub trimString {
    my ($line) = @_;
    chomp($_ = $line);
    s/[\t\s\f]*$//gim;
    s/^[\t\s\f]*//gim;
    return $_;
}

sub cleanWhitespace {
    my ($string) = @_;
    $_ = $string;
    s/\s(?=\s)//gim; s/\t(?=\t)//gim;
    return $_;
}

sub isEmpty {
    my ($obj) = @_;
    if (($obj ne "") || ($obj != 0)) {
        return 0;
    } else {
        return 1;
    }
}

sub cmdMp3 {
    my ($command);
    my ($song_set);
    my (@song);
    my ($song_name, $song_album, $song_author);

    open(HANDLE, "/home/common/dmw-playing-song");
    chomp($song_set = <HANDLE>);

    $song_set = clean_whitespace(trimString($song_set));
    @song = split(/\|/, $song_set);
    if ($#song <= 0) {
        @song = split(/\-/, $song_set);
        if ($#song <= 0) {
            @song = ($song_set);
        }
    }

    if ($#song == 2) {
        $song_author = trimString($song[0]);
        $song_album = trimString($song[1]);
        $song_name = trimString($song[2]);
    } elsif ($#song == 1) {
        $song_author = trimString($song[0]);
        $song_name = trimString($song[1]);
    } elsif ($#song == 0) {
        $song_name = trimString($song[0]);
    } else {
        $song_name = trimString($song_set);
    }

    if (!isEmpty($song_name) && isEmpty($song_author) &&
		isEmpty($song_album)) {
        $command = "/me escucha \002$song_name\002";
    } elsif (!isEmpty($song_name) && !isEmpty($song_author) &&
             isEmpty($song_album)) {
        $command =
			"/me escucha \002$song_author\002:" .
			" \"$song_name\"";
    } elsif (!isEmpty($song_name) && !isEmpty($song_author) &&
             !isEmpty($song_album)) {
        $command =
			"/me escucha \002$song_author\002:" .
			" \"$song_name\"" .
			" \002[\002Album: \002$song_album\002]\002";
    }

    $command .= " \002[\002Irssi/XMMS\002]\002";

    Irssi::active_win()->command($command);
    close(HANDLE);
}

Irssi::command_bind('mp3', 'cmdMp3');

# vim: set ft=perl ff=unix ts=4 sw=4 enc=latin1 expandtab:
